### $ANTLR 2.7.5 (20050629): "gddb-parser.g" -> "GDDBParser.py"$
### import antlr and other modules ..
import sys
import antlr

version = sys.version.split()[0]
if version < '2.2.1':
    False = 0
if version < '2.3':
    True = not False
### header action >>> 
import boolexpr
import os
eFALSE, eTRUE, eAND, eOR, eEND, eINCREMENT, eDECREMENT, eTEST = range( 8 )
stack = []
stack_i = -1
section = ""
eval = True
exe_name = None
volumename = None
### header action <<< 
### preamble action>>>

### preamble action <<<

### import antlr.Token 
from antlr import Token
### >>>The Known Token Types <<<
SKIP                = antlr.SKIP
INVALID_TYPE        = antlr.INVALID_TYPE
EOF_TYPE            = antlr.EOF_TYPE
EOF                 = antlr.EOF
NULL_TREE_LOOKAHEAD = antlr.NULL_TREE_LOOKAHEAD
MIN_USER_TYPE       = antlr.MIN_USER_TYPE
LITERAL_header = 4
LITERAL_installer = 5
LITERAL_game = 6
LITERAL_if = 7
LITERAL_gamenote = 8
LITERAL_and = 9
LITERAL_or = 10
LITERAL_not = 11
LITERAL_true = 12
LITERAL_false = 13
LITERAL_contains = 14
LITERAL_run = 15
LITERAL_volumename = 16
LITERAL_exe_name = 17
WS_ = 18
SL_COMMENT = 19
SH_COMMENT = 20
ML_COMMENT = 21
LBRACE = 22
RBRACE = 23
LCURLY = 24
RCURLY = 25
TILDA = 26
BOR = 27
DOT = 28
LT = 29
GT = 30
LE = 31
GE = 32
EQ = 33
REGEX = 34
NE_COMP = 35
DIGIT = 36
NUMBER = 37
ID = 38
ESC = 39
CHAR_LITERAL = 40
STRING_LITERAL = 41
EXPANSION_LITERAL = 42

class Parser(antlr.LLkParser):
    ### user action >>>
    ### user action <<<
    
    def __init__(self, *args, **kwargs):
        antlr.LLkParser.__init__(self, *args, **kwargs)
        self.tokenNames = _tokenNames
        
    def gddbfile(self):    
        r = None
        
        r = {}
        r["header"] = {}
        r["game"] = {}
        pass
        self.match(LITERAL_header)
        self.match(LCURLY)
        while True:
            if (self.LA(1)==ID):
                pass
                d=self.defline()
                r["header"][d[2]] = d[3]
            else:
                break
            
        self.match(RCURLY)
        while True:
            if (self.LA(1)==LITERAL_game):
                pass
                g=self.game()
                r["game"] = g
            else:
                break
            
        self.match(EOF_TYPE)
        return r
    
    def defline(self):    
        r = None
        
        id = None
        global section
        pass
        id = self.LT(1)
        self.match(ID)
        c=self.const()
        r = ["set", section, id.text, c, id.getLine()]
        return r
    
    def game(self):    
        r = None
        
        s = None
        global exe_name
        global volumename
        r = {}
        r[ "gamenotes" ] = []
        r[ "installer" ] = []
        r[ "run" ] = []
        r[ "general" ] = []
        exe_name = None
        volumename = None
        pass
        self.match(LITERAL_game)
        s = self.LT(1)
        self.match(STRING_LITERAL)
        self.match(LCURLY)
        r["name"] = s.text
        while True:
            if (_tokenSet_0.member(self.LA(1))):
                pass
                s=self.statement()
                r[ "general" ].append( s )
            else:
                break
            
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in [LITERAL_installer]:
            pass
            i=self.installer_clause()
            r[ "installer" ] += i
        elif la1 and la1 in [LITERAL_run,RCURLY]:
            pass
        else:
                raise antlr.NoViableAltException(self.LT(1), self.getFilename())
            
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in [LITERAL_run]:
            pass
            rc=self.run_clause()
            r["run"] += rc
        elif la1 and la1 in [RCURLY]:
            pass
        else:
                raise antlr.NoViableAltException(self.LT(1), self.getFilename())
            
        pass
        self.match(RCURLY)
        r[ "exe" ] = exe_name
        r[ "volume" ] = volumename
        return r
    
    def statement(self):    
        r = None
        
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in [LITERAL_gamenote]:
            pass
            g=self.gamenote()
            r = ["gamenote", g]
        elif la1 and la1 in [LITERAL_if]:
            pass
            i=self.ifstatement()
            r = i
        elif la1 and la1 in [LITERAL_exe_name]:
            pass
            self.exe_line()
        elif la1 and la1 in [LITERAL_volumename]:
            pass
            self.volume_line()
        else:
            if (self.LA(1)==ID) and (_tokenSet_1.member(self.LA(2))):
                pass
                d=self.defline()
                r = d
            elif (self.LA(1)==ID) and (self.LA(2)==LCURLY):
                pass
                s=self.subdefline()
                r = s
            else:
                raise antlr.NoViableAltException(self.LT(1), self.getFilename())
            
        return r
    
    def installer_clause(self):    
        r = None
        
        r = []
        pass
        self.match(LITERAL_installer)
        self.match(LCURLY)
        while True:
            if (_tokenSet_0.member(self.LA(1))):
                pass
                s=self.statement()
                if r != None:
                        r.append(s)
            else:
                break
            
        self.match(RCURLY)
        return r
    
    def run_clause(self):    
        r = None
        
        r = []
        pass
        self.match(LITERAL_run)
        self.match(LCURLY)
        while True:
            if (_tokenSet_0.member(self.LA(1))):
                pass
                s=self.statement()
                r.append(s)
            else:
                break
            
        self.match(RCURLY)
        return r
    
    def gamenote(self):    
        r = None
        
        pass
        self.match(LITERAL_gamenote)
        s=self.const()
        r = s
        return r
    
    def const(self):    
        r = None
        
        c = None
        s = None
        n = None
        id = None
        e = None
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in [CHAR_LITERAL]:
            pass
            c = self.LT(1)
            self.match(CHAR_LITERAL)
            r = c.text
        elif la1 and la1 in [STRING_LITERAL]:
            pass
            s = self.LT(1)
            self.match(STRING_LITERAL)
            r = s.text
        elif la1 and la1 in [NUMBER]:
            pass
            n = self.LT(1)
            self.match(NUMBER)
            r = n.text
        elif la1 and la1 in [LITERAL_true]:
            pass
            self.match(LITERAL_true)
            r = "true"
        elif la1 and la1 in [LITERAL_false]:
            pass
            self.match(LITERAL_false)
            r = "false"
        elif la1 and la1 in [ID]:
            pass
            id = self.LT(1)
            self.match(ID)
            r = id.text
        elif la1 and la1 in [EXPANSION_LITERAL]:
            pass
            e = self.LT(1)
            self.match(EXPANSION_LITERAL)
            r = ""
        else:
                raise antlr.NoViableAltException(self.LT(1), self.getFilename())
            
        return r
    
    def subdefline(self):    
        statements = None
        
        id = None
        statements = []
        global section
        pass
        id = self.LT(1)
        self.match(ID)
        section = id.text
        self.match(LCURLY)
        while True:
            if (_tokenSet_0.member(self.LA(1))):
                pass
                s=self.statement()
                statements.append(s)
            else:
                break
            
        self.match(RCURLY)
        return statements
    
    def ifstatement(self):    
        r = None
        
        token = None
        global stack
        global stack_i
        statements = []
        token_line = 0
        stack_place = 0
        pass
        pass
        token = self.LT(1)
        self.match(LITERAL_if)
        token_line = token.getLine()
        stack.append( [] )
        stack_i += 1
        stack_place = stack_i
        pass
        self.relationalExpression()
        self.match(LCURLY)
        while True:
            if (_tokenSet_0.member(self.LA(1))):
                pass
                s=self.statement()
                statements.append( s )
            else:
                break
            
        pass
        self.match(RCURLY)
        r = [ "if", stack[stack_place], statements, token_line ]
        return r
    
    def exe_line(self):    
        
        global exe_name
        pass
        self.match(LITERAL_exe_name)
        c=self.const()
        exe_name = c
    
    def volume_line(self):    
        
        global volumename
        pass
        self.match(LITERAL_volumename)
        c=self.const()
        volumename = c
    
    def relationalExpression(self):    
        
        pass
        self.relationalORExpression()
    
    def relationalORExpression(self):    
        
        pass
        self.relationalANDExpression()
        while True:
            if (self.LA(1)==LITERAL_or):
                pass
                self.match(LITERAL_or)
                self.relationalANDExpression()
                stack[stack_i].append([eOR])
            else:
                break
            
    
    def relationalANDExpression(self):    
        
        pass
        self.relationalNOTExpression()
        while True:
            if (self.LA(1)==LITERAL_and):
                pass
                self.match(LITERAL_and)
                self.relationalNOTExpression()
                stack[stack_i].append([eAND])
            else:
                break
            
    
    def relationalNOTExpression(self):    
        
        pass
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in [LITERAL_not]:
            pass
            self.match(LITERAL_not)
        elif la1 and la1 in [LITERAL_true,LITERAL_false,LBRACE,NUMBER,ID,CHAR_LITERAL,STRING_LITERAL,EXPANSION_LITERAL]:
            pass
        else:
                raise antlr.NoViableAltException(self.LT(1), self.getFilename())
            
        self.primaryRelationalExpression()
    
    def primaryRelationalExpression(self):    
        
        if (_tokenSet_1.member(self.LA(1))) and (_tokenSet_2.member(self.LA(2))):
            pass
            pass
            n1=self.const()
            op=self.operator()
            n2=self.const()
            stack[stack_i].append( [eTEST, n1, op, n2] )
        elif (self.LA(1)==LITERAL_true) and (_tokenSet_3.member(self.LA(2))):
            pass
            self.match(LITERAL_true)
            stack[stack_i].append([eTRUE])
        elif (self.LA(1)==LITERAL_false) and (_tokenSet_3.member(self.LA(2))):
            pass
            self.match(LITERAL_false)
            stack[stack_i].append([eFALSE])
        elif (self.LA(1)==LBRACE):
            pass
            pass
            self.match(LBRACE)
            stack[stack_i].append([eINCREMENT])
            self.relationalExpression()
            pass
            self.match(RBRACE)
            stack[stack_i].append([eDECREMENT])
        else:
            raise antlr.NoViableAltException(self.LT(1), self.getFilename())
        
    
    def operator(self):    
        r = None
        
        e1 = None
        la1 = self.LA(1)
        if False:
            pass
        elif la1 and la1 in [LT]:
            pass
            self.match(LT)
            r = "<"
        elif la1 and la1 in [GT]:
            pass
            self.match(GT)
            r = ">"
        elif la1 and la1 in [LE]:
            pass
            self.match(LE)
            r = "<="
        elif la1 and la1 in [GE]:
            pass
            self.match(GE)
            r = ">="
        elif la1 and la1 in [EQ]:
            pass
            e1 = self.LT(1)
            self.match(EQ)
            r = "="
        elif la1 and la1 in [NE_COMP]:
            pass
            self.match(NE_COMP)
            r = "!="
        elif la1 and la1 in [LITERAL_contains]:
            pass
            self.match(LITERAL_contains)
            r = "contains"
        elif la1 and la1 in [REGEX]:
            pass
            self.match(REGEX)
            r = "=~"
        else:
                raise antlr.NoViableAltException(self.LT(1), self.getFilename())
            
        return r
    

_tokenNames = [
    "<0>", 
    "EOF", 
    "<2>", 
    "NULL_TREE_LOOKAHEAD", 
    "\"header\"", 
    "\"installer\"", 
    "\"game\"", 
    "\"if\"", 
    "\"gamenote\"", 
    "\"and\"", 
    "\"or\"", 
    "\"not\"", 
    "\"true\"", 
    "\"false\"", 
    "\"contains\"", 
    "\"run\"", 
    "\"volumename\"", 
    "\"exe_name\"", 
    "WS_", 
    "SL_COMMENT", 
    "SH_COMMENT", 
    "ML_COMMENT", 
    "LBRACE", 
    "RBRACE", 
    "LCURLY", 
    "RCURLY", 
    "TILDA", 
    "BOR", 
    "DOT", 
    "LT", 
    "GT", 
    "LE", 
    "GE", 
    "EQ", 
    "REGEX", 
    "NE_COMP", 
    "DIGIT", 
    "NUMBER", 
    "an identifier", 
    "escape sequence", 
    "a character literal", 
    "a string literal", 
    "a shell expansion"
]
    

### generate bit set
def mk_tokenSet_0(): 
    ### var1
    data = [ 274878103936L, 0L]
    return data
_tokenSet_0 = antlr.BitSet(mk_tokenSet_0())

### generate bit set
def mk_tokenSet_1(): 
    ### var1
    data = [ 8108898267136L, 0L]
    return data
_tokenSet_1 = antlr.BitSet(mk_tokenSet_1())

### generate bit set
def mk_tokenSet_2(): 
    ### var1
    data = [ 68182622208L, 0L]
    return data
_tokenSet_2 = antlr.BitSet(mk_tokenSet_2())

### generate bit set
def mk_tokenSet_3(): 
    ### var1
    data = [ 25167360L, 0L]
    return data
_tokenSet_3 = antlr.BitSet(mk_tokenSet_3())
    
