"""
Point2Play Source Code
Copyright 2003, TransGaming Technologies Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""


try:
    import pygtk
    pygtk.require('2.0')
except:
    pass

try:
    import gtk, gobject
except:
    raise beginnersGuideError( _("Unable to load GTK2 Python bindings") )

import sha

class beginnersGuideError(Exception):
    def __init__( self, message ):
        self.message = message

    def __str__( self ):
        return `self.message`


class BeginnersGuideDialog( gtk.Dialog ):
    def __init__( self, fp, title ):
        lines = fp.readlines()
        beginnersGuide_text = ""
        for line in lines:
            beginnersGuide_text = beginnersGuide_text + line
        gtk.Dialog.__init__( self )
        vbox = self.get_children()[0]
        sw = gtk.ScrolledWindow()
        sw.set_size_request( 500, 400 )
        text_view = gtk.TextView()
        text_buffer = text_view.get_buffer()
        text_buffer.set_text( beginnersGuide_text )
        text_view.set_editable( 0 )
        sw.add( text_view )
        vbox.add( sw )
        vbox.show_all()
        self.set_has_separator( 1 )
        self.add_button( _("OK"), 1 )
        self.set_title( title )

    def run( self ):
        response = gtk.Dialog.run( self )
        return response
