"""
Point2Play Source Code
Copyright 2003, TransGaming Technologies Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

try:
    import pygtk
    pygtk.require('2.0')
except:
    pass

import gtk, os

MESSAGE_TG_LOGO=-1

class P2PMessageDialog( gtk.MessageDialog ):
    def __init__(self, parent, destroy, type, buttons, msg ):
        if type == MESSAGE_TG_LOGO:
            gtk.MessageDialog.__init__( self, parent, destroy, gtk.MESSAGE_INFO, buttons, msg )
            try:
                PNG="%s/%s/tg_logo.png" % (os.environ["P2PPATH"], "gui")
            except:
                PNG="tg_logo.png"
            self.get_children()[0].get_children()[0].get_children()[0].set_from_file( PNG )
        else:
            gtk.MessageDialog.__init__( self, parent, destroy, gtk.MESSAGE_INFO, buttons, msg )
        for i in self.action_area.get_children():
            i.set_name( "round_button" )
	
	self.set_resizable( 0 )

class P2PFileSelection( gtk.FileChooserDialog ):
    def __init__( self, dir ):
        if dir:
            gtk.FileChooserDialog.__init__( self ,action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
        else:
            gtk.FileChooserDialog.__init__( self )
        self.set_title("Browse for Program");
        self.add_button(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL)
        self.add_button(gtk.STOCK_OK,gtk.RESPONSE_OK)
        #children = self.get_children()[0].get_children()
        #for i in children[0].get_children():
        #    i.set_name( "round_button" )
        #for i in children[ len( children ) -1 ].get_children():
        #    i.set_name( "round_button" )


	self.set_resizable( 0 )
