#!/usr/bin/env python

"""
Point2Play Source Code
Copyright (c) 2005 by TransGaming Technologies, Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.
"""

import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade
import log, os

p2ppath = os.getenv("P2PPATH")
GLADE_FILE = p2ppath + "/gui/" + __name__ + ".glade"
	
class WidgetsWrapper:
    def __init__(self):
        self.widgets = gtk.glade.XML(GLADE_FILE, None, "p2p_localized_msg")

    # this function lets us do widgets['widget_name'].action()
    def __getitem__(self, key):
        return self.widgets.get_widget(key)

class EntryDialog:
    def __init__(self, dialog_title, prompt_label):
        self.widgets = WidgetsWrapper()
        self.widgets["prompt_label"].set_text(prompt_label)
        self.widgets["entry_dialog"].set_title(dialog_title)
        self.widgets.widgets.signal_autoconnect(self)
