"""
Point2Play Source Code
Copyright 2003, TransGaming Technologies Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

try:
    import pygtk
    pygtk.require('2.0')
except:
    pass

try:
    import gtk, gobject
except:
    raise licenseError( _("Unable to load GTK2 Python bindings") )

import sha

class licenseError(Exception):
    def __init__( self, message ):
        self.message = message

    def __str__( self ):
        return `self.message`

LICENSE_ACCEPT  = 1
LICENSE_DECLINE = 2

class LicenseDialog( gtk.Dialog ):
    def __init__( self, fp ):
        lines = fp.readlines()
        license_text = ""
        for line in lines:
            license_text = license_text + line
        fp.close()
        gtk.Dialog.__init__( self )
        vbox = self.get_children()[0]
        sw = gtk.ScrolledWindow()
        sw.set_size_request( 500, 400 )
        text_view = gtk.TextView()
        text_buffer = text_view.get_buffer()
        text_buffer.set_text( license_text )
        text_view.set_editable( 0 )
        sw.add( text_view )
        vbox.add( sw )
        vbox.show_all()
        self.set_has_separator( 1 )
        self.add_button( gtk.STOCK_CANCEL, LICENSE_DECLINE )
        self.add_button( _("_Accept"), LICENSE_ACCEPT )
        self.set_title( _("License Agreement") )
        self.set_border_width(15)

    def run( self ):
        response = gtk.Dialog.run( self )
        if response == gtk.RESPONSE_DELETE_EVENT:
            response = LICENSE_DECLINE
        return response
